Verify that a value can be called as a function from the current scope.

- « is_bool

- is_countable »

- PHP Manual
- Variable handling Functions
- Verify that a value can be called as a function from the current scope.

# is_callable

(PHP 4 >= 4.0.6, PHP 5, PHP 7, PHP 8)

is_callable — Verify that a value can be called as a function from the current scope.

### Description

is_callable(mixed `$value`, bool `$syntax_only` = `false`, string `&$callable_name` = `null`): bool

Verify that a value is a callable.

### Parameters

`value`

  The value to check

`syntax_only`

  If set to `true` the function only verifies that `value` might be a function or method. It will only reject simple variables that are not strings, or an array that does not have a valid structure to be used as a callback. The valid ones are supposed to have only 2 entries, the first of which is an object or a string, and the second a string.

`callable_name`

  Receives the "callable name". In the example below it is "someClass::someMethod". Note, however, that despite the implication that someClass::SomeMethod() is a callable static method, this is not the case.

### Return Values

Returns `true` if `value` is callable, `false` otherwise.

### Examples

Example #1 is_callable() example

    <?php//  How to check a variable to see if it can be called//  as a function.////  Simple variable containing a function//function someFunction() {}$functionVariable = 'someFunction';var_dump(is_callable($functionVariable, false, $callable_name));  // bool(true)echo $callable_name, "\n";  // someFunction////  Array containing a method//class someClass {  function someMethod()   {  }}$anObject = new someClass();$methodVariable = array($anObject, 'someMethod');var_dump(is_callable($methodVariable, true, $callable_name));  //  bool(true)echo $callable_name, "\n";  //  someClass::someMethod?>

Example #2 is_callable() and constructors

is_callable() reports constructors as not being callable.

    <?phpclass Foo{    public function __construct() {}    public function foo() {}}var_dump(    is_callable(array('Foo', '__construct')),    is_callable(array('Foo', 'foo')));

The above example will output:

    bool(false)
    bool(false)

### Notes

- An object is always callable if it implements __invoke(), and that method is visible in the current scope.
- A class name is callable if it implements __callStatic().
- If an object implements __call(), then this function will return `true` for any method on that object, even if the method is not defined.
- This function may trigger autoloading if called with the name of a class.

### See Also

- function_exists() - Return true if the given function has been defined
- method_exists() - Checks if the class method exists